import os
import sys
script_directory = os.path.dirname(os.path.abspath(__file__))
sys.path.append(os.path.join(script_directory, '..'))

from dotenv import load_dotenv
from db import contactView
from contact_api.contact import contact
from logger_local.Logger import Logger
from logger_local.LoggerComponentEnum import LoggerComponentEnum


load_dotenv()
CONTACT_LOCAL_PYTHON_COMPONENT_ID=123
CONTACT_LOCAL_PYTHON_COMPONENT_NAME='contact-local'

obj = {
    'component_id': CONTACT_LOCAL_PYTHON_COMPONENT_ID,
    'component_name': CONTACT_LOCAL_PYTHON_COMPONENT_NAME,
    'component_category':LoggerComponentEnum.ComponentCategory.Code.value,
    'developer_email':'shavit.m@circ.zone'
    
}

logger=Logger.create_logger(object=obj)


def test_insert_select():

    logger.start()
    contact.insert("ai","bye","0539229102","","sami@gmail.com","haifa","sniper","wha")
    contactRes = contactView.get_contact_by_first_name('ai')
    contactRes is not None
    logger.end("contact added "+"ai")




def test_update():
    object1 = {
           'name' :'manana'
        }
   
    logger.start(object=object1)
    first_name="manana"
    last_name="banana"
    phone="01291921"
    birthday=""
    email="sasa@gmail.com"
    location="here"
    job_title="jobber"
    organization="what"

    

    id=contact.insert(first_name,last_name,phone,
                    birthday,email,location,job_title,organization)
    
    person_id=11 
    name_prefix="sami"
    first_name="ve"
    additional_name='sumo'
    job_title="ars"

    contact.update(person_id, name_prefix, first_name, additional_name, job_title, id)
    contactRes = contactView.get_contact_by_id(id)
    print(contactRes[3])
    assert contactRes[3] == person_id
    assert contactRes[6] == name_prefix
    assert contactRes[7] == first_name
    assert contactRes[8] == additional_name
    assert contactRes[17] == job_title
    logger.end("success")



def test_insert_multi():
 
    logger.start()
    contacts_to_insert = [
    {
        'first_name': 'John',
        'last_name': 'Doe',
        'phone': '123-456-7890',
        'birthday': '',
        'email': 'john@example.com',
        'location': '123 Main St',
        'job_title': 'Software Developer',
        'organization': 'Tech Company'
    },
    {
        'first_name': 'Jane',
        'last_name': 'Smith',
        'phone': '987-654-3210',
        'birthday': '',
        'email': 'jane@example.com',
        'location': '456 Elm St',
        'job_title': 'Frontend Developer',
        'organization': 'Web Solutions'
    }
]

    inserted_ids = contact.insert_batch(contacts_to_insert)
    inserted_ids is not None
    logger.end("success")
